#property copyright "Coded by FerruFx 2013 - www.ervent.net"
#property link      "http://www.ervent.net"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 3.0
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Crimson
#property indicator_color3 DimGray
#property indicator_color4 DimGray

extern string Label1 = "=== Timeframes To Display ===";
extern string Timeframes = "M1,M5,M15,M30,H1,H4,D1,W1,MN";
extern int Candles_per_TF = 28;
extern string Label2 = "=== Stochastic Settings ===";
extern int KPeriod = 5;
extern int DPeriod = 3;
extern int Slowing = 3;
extern int MAMethod = 0;
extern int PriceField = 0;
extern int OverBought_Level = 80;
extern int OverSold_Level = 20;
extern string Label3 = "=== Color Settings ===";
extern color BackgroundColor = C'0x0F,0x0F,0x0F';
extern color BorderColor = C'0x46,0x46,0x46';
extern color TimeframeColor = Yellow;
extern string Label4 = "=== Alerts Settings ===";
extern bool Alert_at_Stoch_cross_in_OBOS = FALSE;
extern bool Alert_at_Stoch_cross_out_OBOS = FALSE;
extern bool Alert_at_Stoch_cross_Signal = FALSE;
extern bool Alert_at_Candle_Close = TRUE;
extern bool SoundAlert = FALSE;
extern bool PopUpAlert = FALSE;
extern bool SendAlertEmail = FALSE;
extern bool SendAlertPush = FALSE;
int Gi_192;
int Gia_196[10];
string Gs_200;
string Gsa_208[10];
double G_ibuf_212[];
double G_ibuf_216[];
double G_ibuf_220[];
double G_ibuf_224[];
double Gd_228;
double Gd_236;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorDigits(Digits + 1);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, G_ibuf_212);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, G_ibuf_216);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, G_ibuf_220);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, G_ibuf_224);
   SetIndexLabel(0, "");
   SetIndexLabel(1, "");
   SetIndexLabel(2, "");
   SetIndexLabel(3, "");
   SetIndexDrawBegin(0, KPeriod);
   SetIndexDrawBegin(1, DPeriod);
   Gs_200 = "FFx Stochastic [" + DoubleToStr(KPeriod, 0) + "," + DoubleToStr(DPeriod, 0) + "," + DoubleToStr(Slowing, 0) + "] ==> by FerruFx";
   IndicatorShortName(Gs_200);
   f0_3();
   if (ObjectFind("FFx_Stochastic_alert_M1") != -1 && StringFind(Timeframes, "M1") == -1) ObjectDelete("FFx_Stochastic_alert_M1");
   if (ObjectFind("FFx_Stochastic_alert_M5") != -1 && StringFind(Timeframes, "M5") == -1) ObjectDelete("FFx_Stochastic_alert_M5");
   if (ObjectFind("FFx_Stochastic_alert_M15") != -1 && StringFind(Timeframes, "M15") == -1) ObjectDelete("FFx_Stochastic_alert_M15");
   if (ObjectFind("FFx_Stochastic_alert_M30") != -1 && StringFind(Timeframes, "M30") == -1) ObjectDelete("FFx_Stochastic_alert_M30");
   if (ObjectFind("FFx_Stochastic_alert_H1") != -1 && StringFind(Timeframes, "H1") == -1) ObjectDelete("FFx_Stochastic_alert_H1");
   if (ObjectFind("FFx_Stochastic_alert_H4") != -1 && StringFind(Timeframes, "H4") == -1) ObjectDelete("FFx_Stochastic_alert_H4");
   if (ObjectFind("FFx_Stochastic_alert_D1") != -1 && StringFind(Timeframes, "D1") == -1) ObjectDelete("FFx_Stochastic_alert_D1");
   if (ObjectFind("FFx_Stochastic_alert_W1") != -1 && StringFind(Timeframes, "W1") == -1) ObjectDelete("FFx_Stochastic_alert_W1");
   if (ObjectFind("FFx_Stochastic_alert_MN") != -1 && StringFind(Timeframes, "MN") == -1) ObjectDelete("FFx_Stochastic_alert_MN");
   f0_1();
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   string name_0;
   int objs_total_8 = ObjectsTotal();
   for (int Li_12 = objs_total_8 - 1; Li_12 >= 0; Li_12--) {
      name_0 = ObjectName(Li_12);
      if (StringFind(name_0, "FFx_Stochastic_") != -1 && StringFind(name_0, "FFx_Stochastic_alert_") == -1) ObjectDelete(name_0);
   }
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   RefreshRates();
   for (int Li_0 = 1000; Li_0 >= 0; Li_0--) {
      G_ibuf_212[Li_0] = EMPTY_VALUE;
      G_ibuf_216[Li_0] = EMPTY_VALUE;
      G_ibuf_220[Li_0] = EMPTY_VALUE;
      G_ibuf_224[Li_0] = EMPTY_VALUE;
   }
   int Li_4 = 0;
   for (int index_8 = 0; index_8 < Gi_192; index_8++) {
      if (Li_4 == 0) {
         f0_2("FFx_Stochastic_rect_" + Gsa_208[index_8], "", OBJ_RECTANGLE, Time[Li_4] + 60 * (Period() * 2), 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BackgroundColor, TRUE,
            "", 9);
      } else f0_2("FFx_Stochastic_rect_" + Gsa_208[index_8], "", OBJ_RECTANGLE, Time[Li_4 - 2], 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BackgroundColor, TRUE, "", 9);
      if (Li_4 == 0) {
         f0_2("FFx_Stochastic_bord_" + Gsa_208[index_8], "", OBJ_RECTANGLE, Time[Li_4] + 60 * (Period() * 2), 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BorderColor, FALSE,
            "", 9);
      } else f0_2("FFx_Stochastic_bord_" + Gsa_208[index_8], "", OBJ_RECTANGLE, Time[Li_4 - 2], 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BorderColor, FALSE, "", 9);
      f0_2("FFx_Stochastic_tf_" + Gsa_208[index_8], Gsa_208[index_8], OBJ_TEXT, Time[Candles_per_TF - 2 + Li_4], 0.4, 0, 0, TimeframeColor, FALSE, "Arial Bold", 9);
      if (SoundAlert || PopUpAlert || SendAlertEmail || SendAlertPush) {
         if (ObjectFind("FFx_Stochastic_alert_" + Gsa_208[index_8]) != -1 && ObjectGet("FFx_Stochastic_alert_" + Gsa_208[index_8], OBJPROP_PRICE1) != 0.4) {
            if (ObjectGet("FFx_Stochastic_alert_" + Gsa_208[index_8], OBJPROP_COLOR) == 65280.0) {
               ObjectDelete("FFx_Stochastic_alert_" + Gsa_208[index_8]);
               f0_2("FFx_Stochastic_alert_" + Gsa_208[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Red, FALSE, "MS Outlook", 8);
            } else {
               if (ObjectGet("FFx_Stochastic_alert_" + Gsa_208[index_8], OBJPROP_COLOR) == 255.0) {
                  ObjectDelete("FFx_Stochastic_alert_" + Gsa_208[index_8]);
                  f0_2("FFx_Stochastic_alert_" + Gsa_208[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Lime, FALSE, "MS Outlook", 8);
               }
            }
         }
      }
      if (ObjectGet("FFx_Stochastic_alert_" + Gsa_208[index_8], OBJPROP_COLOR) == 65280.0) f0_2("FFx_Stochastic_alert_" + Gsa_208[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Lime, FALSE, "MS Outlook", 8);
      else f0_2("FFx_Stochastic_alert_" + Gsa_208[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Red, FALSE, "MS Outlook", 8);
      for (Li_0 = Candles_per_TF + Li_4; Li_0 >= Li_4; Li_0--) {
         Gd_236 = 100;
         Gd_228 = 0;
         G_ibuf_212[Li_0] = 2.2 * (f0_0(f0_4(Gsa_208[index_8]), MODE_MAIN, Li_0 - Li_4) - Gd_228) / (Gd_236 - Gd_228) + 0.4;
         G_ibuf_216[Li_0] = 2.2 * (f0_0(f0_4(Gsa_208[index_8]), MODE_SIGNAL, Li_0 - Li_4) - Gd_228) / (Gd_236 - Gd_228) + 0.4;
         G_ibuf_220[Li_0] = 2.2 * (OverBought_Level - Gd_228) / (Gd_236 - Gd_228) + 0.4;
         G_ibuf_224[Li_0] = 2.2 * (OverSold_Level - Gd_228) / (Gd_236 - Gd_228) + 0.4;
         if (ObjectGet("FFx_Stochastic_alert_" + Gsa_208[index_8], OBJPROP_COLOR) == 65280.0 && Gia_196[index_8] != iTime(Symbol(), f0_4(Gsa_208[index_8]), 0)) {
            if (Li_0 == Li_4) {
               if (Alert_at_Stoch_cross_in_OBOS) {
                  if (G_ibuf_212[Li_0 + Alert_at_Candle_Close] > G_ibuf_220[Li_0 + Alert_at_Candle_Close] && G_ibuf_212[Li_0 + Alert_at_Candle_Close + 1] <= G_ibuf_220[Li_0 + Alert_at_Candle_Close +
                     1]) {
                     f0_5("Stoch crossed above " + DoubleToStr(OverBought_Level, 0) + " Level on " + Symbol() + " " + Gsa_208[index_8]);
                     Gia_196[index_8] = iTime(Symbol(), f0_4(Gsa_208[index_8]), 0);
                  } else {
                     if (G_ibuf_212[Li_0 + Alert_at_Candle_Close] < G_ibuf_224[Li_0 + Alert_at_Candle_Close] && G_ibuf_212[Li_0 + Alert_at_Candle_Close + 1] >= G_ibuf_224[Li_0 + Alert_at_Candle_Close +
                        1]) {
                        f0_5("Stoch crossed below " + DoubleToStr(OverSold_Level, 0) + " Level on " + Symbol() + " " + Gsa_208[index_8]);
                        Gia_196[index_8] = iTime(Symbol(), f0_4(Gsa_208[index_8]), 0);
                     }
                  }
               }
               if (Alert_at_Stoch_cross_out_OBOS) {
                  if (G_ibuf_212[Li_0 + Alert_at_Candle_Close] < G_ibuf_220[Li_0 + Alert_at_Candle_Close] && G_ibuf_212[Li_0 + Alert_at_Candle_Close + 1] >= G_ibuf_220[Li_0 + Alert_at_Candle_Close +
                     1]) {
                     f0_5("Stoch crossed below " + DoubleToStr(OverBought_Level, 0) + " Level on " + Symbol() + " " + Gsa_208[index_8]);
                     Gia_196[index_8] = iTime(Symbol(), f0_4(Gsa_208[index_8]), 0);
                  } else {
                     if (G_ibuf_212[Li_0 + Alert_at_Candle_Close] > G_ibuf_224[Li_0 + Alert_at_Candle_Close] && G_ibuf_212[Li_0 + Alert_at_Candle_Close + 1] <= G_ibuf_224[Li_0 + Alert_at_Candle_Close +
                        1]) {
                        f0_5("Stoch crossed above " + DoubleToStr(OverSold_Level, 0) + " Level on " + Symbol() + " " + Gsa_208[index_8]);
                        Gia_196[index_8] = iTime(Symbol(), f0_4(Gsa_208[index_8]), 0);
                     }
                  }
               }
               if (Alert_at_Stoch_cross_Signal) {
                  if (G_ibuf_212[Li_0 + Alert_at_Candle_Close] > G_ibuf_216[Li_0 + Alert_at_Candle_Close] && G_ibuf_212[Li_0 + Alert_at_Candle_Close + 1] <= G_ibuf_216[Li_0 + Alert_at_Candle_Close +
                     1]) {
                     f0_5("Stoch crossed above Signal on " + Symbol() + " " + Gsa_208[index_8]);
                     Gia_196[index_8] = iTime(Symbol(), f0_4(Gsa_208[index_8]), 0);
                     continue;
                  }
                  if (G_ibuf_212[Li_0 + Alert_at_Candle_Close] < G_ibuf_216[Li_0 + Alert_at_Candle_Close] && G_ibuf_212[Li_0 + Alert_at_Candle_Close + 1] >= G_ibuf_216[Li_0 + Alert_at_Candle_Close +
                     1]) {
                     f0_5("Stoch crossed below Signal on " + Symbol() + " " + Gsa_208[index_8]);
                     Gia_196[index_8] = iTime(Symbol(), f0_4(Gsa_208[index_8]), 0);
                  }
               }
            }
         }
      }
      Li_4 += Candles_per_TF + 5;
   }
   return (0);
}

// 0576080CDA9C7871E4CEEB9E083DB0AB
double f0_0(int A_timeframe_0, int Ai_4, int A_shift_8) {
   return (iStochastic(Symbol(), A_timeframe_0, KPeriod, DPeriod, Slowing, MAMethod, PriceField, Ai_4, A_shift_8));
}

// 58C7E3173A83184FE920CDD1203C3DCF
void f0_3() {
   int index_0 = 0;
   int Li_4 = 0;
   int Li_8 = 1;
   while (index_0 < 10 && Li_8 > 0) {
      Li_8 = StringFind(Timeframes, ",", Li_4);
      if (Li_8 == 0) Gsa_208[index_0] = StringSubstr(Timeframes, Li_4, 0);
      else Gsa_208[index_0] = StringSubstr(Timeframes, Li_4, Li_8 - Li_4);
      Gsa_208[index_0] = f0_7(Gsa_208[index_0]);
      index_0++;
      Li_4 = StringFind(Timeframes, ",", Li_4) + 1;
      if (Li_4 == 0) break;
   }
   Gi_192 = index_0;
}

// BE5275EB85F7B577DA8FD065F994B740
string f0_7(string As_0) {
   As_0 = f0_6(As_0);
   if (As_0 == "1") return ("M1");
   if (As_0 == "5") return ("M5");
   if (As_0 == "15") return ("M15");
   if (As_0 == "30") return ("M30");
   if (As_0 == "60") return ("H1");
   if (As_0 == "240") return ("H4");
   if (As_0 == "1440") return ("D1");
   if (As_0 == "10080") return ("W1");
   if (As_0 == "43200") return ("MN");
   return (As_0);
}

// 615FDEF187331094F307B857EA2ECFD3
int f0_4(string As_0) {
   int timeframe_8 = Period();
   if (As_0 == "M1" || As_0 == "1") timeframe_8 = 1;
   if (As_0 == "M5" || As_0 == "5") timeframe_8 = 5;
   if (As_0 == "M15" || As_0 == "15") timeframe_8 = 15;
   if (As_0 == "M30" || As_0 == "30") timeframe_8 = 30;
   if (As_0 == "H1" || As_0 == "60") timeframe_8 = 60;
   if (As_0 == "H4" || As_0 == "240") timeframe_8 = 240;
   if (As_0 == "D1" || As_0 == "1440") timeframe_8 = 1440;
   if (As_0 == "W1" || As_0 == "10080") timeframe_8 = 10080;
   if (As_0 == "MN" || As_0 == "43200") timeframe_8 = 43200;
   return (timeframe_8);
}

// 92DFF40263F725411B5FB6096A8D564E
string f0_6(string As_0) {
   int Li_20;
   string Ls_ret_8 = As_0;
   for (int Li_16 = StringLen(As_0) - 1; Li_16 >= 0; Li_16--) {
      Li_20 = StringGetChar(Ls_ret_8, Li_16);
      if ((Li_20 > '`' && Li_20 < '{') || (Li_20 > '' && Li_20 < 256)) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 - 32);
      else
         if (Li_20 > -33 && Li_20 < 0) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 + 224);
   }
   return (Ls_ret_8);
}

// 5891DA2D64975CAE48D175D1E001F5DA
void f0_2(string A_name_0, string A_text_8, int Ai_16, int A_datetime_20, double Ad_24, int A_datetime_32, double Ad_36, color A_color_44, int A_bool_48, string A_fontname_52, int A_fontsize_60) {
   if (ObjectFind(A_name_0) == -1) ObjectCreate(A_name_0, Ai_16, WindowFind(Gs_200), 0, 0, 0, 0);
   ObjectSet(A_name_0, OBJPROP_PRICE1, Ad_24);
   ObjectSet(A_name_0, OBJPROP_PRICE2, Ad_36);
   ObjectSet(A_name_0, OBJPROP_TIME1, A_datetime_20);
   ObjectSet(A_name_0, OBJPROP_TIME2, A_datetime_32);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_44);
   if (StringFind(A_name_0, "body") != -1) ObjectSet(A_name_0, OBJPROP_WIDTH, 3);
   else ObjectSet(A_name_0, OBJPROP_WIDTH, 1);
   ObjectSet(A_name_0, OBJPROP_BACK, A_bool_48);
   ObjectSet(A_name_0, OBJPROP_RAY, FALSE);
   ObjectSetText(A_name_0, A_text_8, A_fontsize_60, A_fontname_52, A_color_44);
}

// 7ED21143076D0CCA420653D4345BAA2F
void f0_5(string As_0) {
   if (SoundAlert) PlaySound("alert.wav");
   if (PopUpAlert) Alert("FFx Stochastic Alert - ", As_0, " at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
   if (SendAlertEmail) SendMail("FFx Stochastic Alert", "FFx Stochastic Alert - " + As_0 + " at " + TimeToStr(TimeCurrent(), TIME_SECONDS) + " (server time)");
   if (SendAlertPush) SendNotification("FFx Stochastic Alert - " + As_0 + " at " + TimeToStr(TimeCurrent(), TIME_SECONDS) + " (server time)");
}

// 205812AC4EF56AE14BAD4AAAA8876DCC
void f0_1() {
   string name_0 = "ferrufx";
   if (ObjectFind(name_0) == -1) ObjectCreate(name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name_0, OBJPROP_CORNER, 2);
   ObjectSet(name_0, OBJPROP_XDISTANCE, 3);
   ObjectSet(name_0, OBJPROP_YDISTANCE, 2);
   ObjectSetText(name_0, "FerruFx / www.ervent.net", 8, "Verdana", C'0x3C,0x3C,0x3C');
}