#property copyright "Coded by FerruFx 2013 - www.ervent.net"
#property link      "http://www.ervent.net"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 3.0
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Yellow
#property indicator_color3 Yellow

extern string Label1 = "=== Timeframes To Display ===";
extern string Timeframes = "M1,M5,M15,M30,H1,H4,D1,W1,MN";
extern int Candles_per_TF = 28;
extern string Label2 = "=== Bollinger Bands Settings ===";
extern int Period_ = 20;
extern int Shift = 0;
extern int Deviations = 2;
extern int ApplyTo = 0;
extern string Label3 = "=== Color Settings ===";
extern color BackgroundColor = C'0x0F,0x0F,0x0F';
extern color BorderColor = C'0x46,0x46,0x46';
extern color TimeframeColor = Yellow;
extern color BullCandleColor = Green;
extern color BearCandleColor = Crimson;
extern string Label4 = "=== Alerts Settings ===";
extern bool Alert_at_UpperLowerBand_cross = FALSE;
extern bool Alert_at_MidBand_cross = FALSE;
extern bool Alert_at_Candle_Close = TRUE;
extern bool SoundAlert = FALSE;
extern bool PopUpAlert = FALSE;
extern bool SendAlertEmail = FALSE;
extern bool SendAlertPush = FALSE;
int G_color_184;
int Gi_188;
int Gia_192[10];
string Gs_196;
string Gsa_204[10];
double G_ibuf_208[];
double G_ibuf_212[];
double G_ibuf_216[];
double Gd_220;
double Gd_228;
double G_iopen_236;
double G_iclose_244;
double G_ihigh_252;
double G_ilow_260;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   IndicatorDigits(Digits + 1);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, G_ibuf_212);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, G_ibuf_208);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, G_ibuf_216);
   SetIndexLabel(0, "");
   SetIndexLabel(1, "");
   SetIndexLabel(2, "");
   SetIndexDrawBegin(0, Period_);
   SetIndexDrawBegin(1, Period_);
   SetIndexDrawBegin(2, Period_);
   Gs_196 = "FFx BollingerBands [" + DoubleToStr(Period_, 0) + "," + DoubleToStr(Deviations, 0) + "] ==> by FerruFx";
   IndicatorShortName(Gs_196);
   f0_3();
   if (ObjectFind("FFx_BollingerBands_alert_M1") != -1 && StringFind(Timeframes, "M1") == -1) ObjectDelete("FFx_BollingerBands_alert_M1");
   if (ObjectFind("FFx_BollingerBands_alert_M5") != -1 && StringFind(Timeframes, "M5") == -1) ObjectDelete("FFx_BollingerBands_alert_M5");
   if (ObjectFind("FFx_BollingerBands_alert_M15") != -1 && StringFind(Timeframes, "M15") == -1) ObjectDelete("FFx_BollingerBands_alert_M15");
   if (ObjectFind("FFx_BollingerBands_alert_M30") != -1 && StringFind(Timeframes, "M30") == -1) ObjectDelete("FFx_BollingerBands_alert_M30");
   if (ObjectFind("FFx_BollingerBands_alert_H1") != -1 && StringFind(Timeframes, "H1") == -1) ObjectDelete("FFx_BollingerBands_alert_H1");
   if (ObjectFind("FFx_BollingerBands_alert_H4") != -1 && StringFind(Timeframes, "H4") == -1) ObjectDelete("FFx_BollingerBands_alert_H4");
   if (ObjectFind("FFx_BollingerBands_alert_D1") != -1 && StringFind(Timeframes, "D1") == -1) ObjectDelete("FFx_BollingerBands_alert_D1");
   if (ObjectFind("FFx_BollingerBands_alert_W1") != -1 && StringFind(Timeframes, "W1") == -1) ObjectDelete("FFx_BollingerBands_alert_W1");
   if (ObjectFind("FFx_BollingerBands_alert_MN") != -1 && StringFind(Timeframes, "MN") == -1) ObjectDelete("FFx_BollingerBands_alert_MN");
   f0_0();
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   string name_0;
   int objs_total_8 = ObjectsTotal();
   for (int Li_12 = objs_total_8 - 1; Li_12 >= 0; Li_12--) {
      name_0 = ObjectName(Li_12);
      if (StringFind(name_0, "FFx_BollingerBands_") != -1 && StringFind(name_0, "FFx_BollingerBands_alert_") == -1) ObjectDelete(name_0);
   }
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   RefreshRates();
   for (int Li_0 = 1000; Li_0 >= 0; Li_0--) {
      G_ibuf_208[Li_0] = EMPTY_VALUE;
      G_ibuf_212[Li_0] = EMPTY_VALUE;
      G_ibuf_216[Li_0] = EMPTY_VALUE;
   }
   int Li_4 = 0;
   for (int index_8 = 0; index_8 < Gi_188; index_8++) {
      if (Li_4 == 0) {
         f0_2("FFx_BollingerBands_rect_" + Gsa_204[index_8], "", OBJ_RECTANGLE, Time[Li_4] + 60 * (Period() * 2), 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BackgroundColor,
            TRUE, "", 9);
      } else f0_2("FFx_BollingerBands_rect_" + Gsa_204[index_8], "", OBJ_RECTANGLE, Time[Li_4 - 2], 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BackgroundColor, TRUE, "", 9);
      if (Li_4 == 0) {
         f0_2("FFx_BollingerBands_bord_" + Gsa_204[index_8], "", OBJ_RECTANGLE, Time[Li_4] + 60 * (Period() * 2), 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BorderColor, FALSE,
            "", 9);
      } else f0_2("FFx_BollingerBands_bord_" + Gsa_204[index_8], "", OBJ_RECTANGLE, Time[Li_4 - 2], 2.7, Time[Li_4 + Candles_per_TF + 2], 0.1, BorderColor, FALSE, "", 9);
      f0_2("FFx_BollingerBands_tf_" + Gsa_204[index_8], Gsa_204[index_8], OBJ_TEXT, Time[Candles_per_TF - 2 + Li_4], 0.4, 0, 0, TimeframeColor, FALSE, "Arial Bold", 9);
      if (SoundAlert || PopUpAlert || SendAlertEmail || SendAlertPush) {
         if (ObjectFind("FFx_BollingerBands_alert_" + Gsa_204[index_8]) != -1 && ObjectGet("FFx_BollingerBands_alert_" + Gsa_204[index_8], OBJPROP_PRICE1) != 0.4) {
            if (ObjectGet("FFx_BollingerBands_alert_" + Gsa_204[index_8], OBJPROP_COLOR) == 65280.0) {
               ObjectDelete("FFx_BollingerBands_alert_" + Gsa_204[index_8]);
               f0_2("FFx_BollingerBands_alert_" + Gsa_204[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Red, FALSE, "MS Outlook", 8);
            } else {
               if (ObjectGet("FFx_BollingerBands_alert_" + Gsa_204[index_8], OBJPROP_COLOR) == 255.0) {
                  ObjectDelete("FFx_BollingerBands_alert_" + Gsa_204[index_8]);
                  f0_2("FFx_BollingerBands_alert_" + Gsa_204[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Lime, FALSE, "MS Outlook", 8);
               }
            }
         }
      }
      if (ObjectGet("FFx_BollingerBands_alert_" + Gsa_204[index_8], OBJPROP_COLOR) == 65280.0) f0_2("FFx_BollingerBands_alert_" + Gsa_204[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Lime, FALSE, "MS Outlook", 8);
      else f0_2("FFx_BollingerBands_alert_" + Gsa_204[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], 0.4, 0, 0, Red, FALSE, "MS Outlook", 8);
      for (Li_0 = Candles_per_TF + Li_4; Li_0 >= Li_4; Li_0--) {
         f0_7(f0_4(Gsa_204[index_8]), Li_0 - Li_4);
         G_ibuf_212[Li_0] = 2.2 * (f0_1(f0_4(Gsa_204[index_8]), MODE_UPPER, Li_0 - Li_4) - Gd_220) / (Gd_228 - Gd_220) + 0.4;
         G_ibuf_208[Li_0] = 2.2 * (f0_8(f0_4(Gsa_204[index_8]), Li_0 - Li_4) - Gd_220) / (Gd_228 - Gd_220) + 0.4;
         G_ibuf_216[Li_0] = 2.2 * (f0_1(f0_4(Gsa_204[index_8]), MODE_LOWER, Li_0 - Li_4) - Gd_220) / (Gd_228 - Gd_220) + 0.4;
         G_iopen_236 = iOpen(Symbol(), f0_4(Gsa_204[index_8]), Li_0 - Li_4);
         G_iclose_244 = iClose(Symbol(), f0_4(Gsa_204[index_8]), Li_0 - Li_4);
         G_ihigh_252 = iHigh(Symbol(), f0_4(Gsa_204[index_8]), Li_0 - Li_4);
         G_ilow_260 = iLow(Symbol(), f0_4(Gsa_204[index_8]), Li_0 - Li_4);
         if (G_iopen_236 < G_iclose_244) G_color_184 = BullCandleColor;
         else G_color_184 = BearCandleColor;
         ObjectDelete("FFx_BollingerBands_body_" + Li_0 + "_" + Gsa_204[index_8]);
         ObjectDelete("FFx_BollingerBands_wick_" + Li_0 + "_" + Gsa_204[index_8]);
         f0_2("FFx_BollingerBands_body_" + Li_0 + "_" + Gsa_204[index_8], Gsa_204[index_8], OBJ_TREND, Time[Li_0], 2.2 * (G_iopen_236 - Gd_220) / (Gd_228 - Gd_220) + 0.4,
            Time[Li_0], 2.2 * (G_iclose_244 - Gd_220) / (Gd_228 - Gd_220) + 0.4, G_color_184, TRUE, "Arial Bold", 9);
         f0_2("FFx_BollingerBands_wick_" + Li_0 + "_" + Gsa_204[index_8], Gsa_204[index_8], OBJ_TREND, Time[Li_0], 2.2 * (G_ihigh_252 - Gd_220) / (Gd_228 - Gd_220) + 0.4,
            Time[Li_0], 2.2 * (G_ilow_260 - Gd_220) / (Gd_228 - Gd_220) + 0.4, G_color_184, TRUE, "Arial Bold", 9);
         if (ObjectGet("FFx_BollingerBands_alert_" + Gsa_204[index_8], OBJPROP_COLOR) == 65280.0 && Gia_192[index_8] != iTime(Symbol(), f0_4(Gsa_204[index_8]), 0)) {
            if (Li_0 == Li_4) {
               if (Alert_at_UpperLowerBand_cross) {
                  if (iClose(Symbol(), f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) > f0_1(f0_4(Gsa_204[index_8]), MODE_UPPER, Alert_at_Candle_Close) && iClose(Symbol(), f0_4(Gsa_204[index_8]),
                     Alert_at_Candle_Close + 1) <= f0_1(f0_4(Gsa_204[index_8]), MODE_UPPER, Alert_at_Candle_Close + 1)) {
                     f0_5("Price closed above UpperBand on " + Symbol() + " " + Gsa_204[index_8]);
                     Gia_192[index_8] = iTime(Symbol(), f0_4(Gsa_204[index_8]), 0);
                  } else {
                     if (iClose(Symbol(), f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) < f0_1(f0_4(Gsa_204[index_8]), MODE_LOWER, Alert_at_Candle_Close) && iClose(Symbol(), f0_4(Gsa_204[index_8]),
                        Alert_at_Candle_Close + 1) >= f0_1(f0_4(Gsa_204[index_8]), MODE_LOWER, Alert_at_Candle_Close + 1)) {
                        f0_5("Price closed below LowerBand on " + Symbol() + " " + Gsa_204[index_8]);
                        Gia_192[index_8] = iTime(Symbol(), f0_4(Gsa_204[index_8]), 0);
                     } else {
                        if (iClose(Symbol(), f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) < f0_1(f0_4(Gsa_204[index_8]), MODE_UPPER, Alert_at_Candle_Close) && iClose(Symbol(), f0_4(Gsa_204[index_8]),
                           Alert_at_Candle_Close + 1) >= f0_1(f0_4(Gsa_204[index_8]), MODE_UPPER, Alert_at_Candle_Close + 1)) {
                           f0_5("Price closed below UpperBand on " + Symbol() + " " + Gsa_204[index_8]);
                           Gia_192[index_8] = iTime(Symbol(), f0_4(Gsa_204[index_8]), 0);
                        } else {
                           if (iClose(Symbol(), f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) > f0_1(f0_4(Gsa_204[index_8]), MODE_LOWER, Alert_at_Candle_Close) && iClose(Symbol(), f0_4(Gsa_204[index_8]),
                              Alert_at_Candle_Close + 1) <= f0_1(f0_4(Gsa_204[index_8]), MODE_LOWER, Alert_at_Candle_Close + 1)) {
                              f0_5("Price closed above LowerBand on " + Symbol() + " " + Gsa_204[index_8]);
                              Gia_192[index_8] = iTime(Symbol(), f0_4(Gsa_204[index_8]), 0);
                           }
                        }
                     }
                  }
               }
               if (Alert_at_MidBand_cross) {
                  if (iClose(Symbol(), f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) > f0_8(f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) && iClose(Symbol(), f0_4(Gsa_204[index_8]),
                     Alert_at_Candle_Close + 1) <= f0_8(f0_4(Gsa_204[index_8]), Alert_at_Candle_Close + 1)) {
                     f0_5("Price closed above MidBand on " + Symbol() + " " + Gsa_204[index_8]);
                     Gia_192[index_8] = iTime(Symbol(), f0_4(Gsa_204[index_8]), 0);
                     continue;
                  }
                  if (iClose(Symbol(), f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) < f0_8(f0_4(Gsa_204[index_8]), Alert_at_Candle_Close) && iClose(Symbol(), f0_4(Gsa_204[index_8]),
                     Alert_at_Candle_Close + 1) >= f0_8(f0_4(Gsa_204[index_8]), Alert_at_Candle_Close + 1)) {
                     f0_5("Price closed below MidBand on " + Symbol() + " " + Gsa_204[index_8]);
                     Gia_192[index_8] = iTime(Symbol(), f0_4(Gsa_204[index_8]), 0);
                  }
               }
            }
         }
      }
      Li_4 += Candles_per_TF + 5;
   }
   return (0);
}

// B74DF323E3939B563635A2CBA7A7AFBA
double f0_8(int A_timeframe_0, int Ai_4) {
   return (iMA(Symbol(), A_timeframe_0, Period_, Shift, MODE_SMA, ApplyTo, Ai_4));
}

// 21AD0BD836B90D08F4CF640B4C298E7C
double f0_1(int A_timeframe_0, int Ai_4, int A_shift_8) {
   return (iBands(Symbol(), A_timeframe_0, Period_, Deviations, Shift, ApplyTo, Ai_4, A_shift_8));
}

// A4FF04F48E6F2EB804B28A49CBCE7769
void f0_7(int A_timeframe_0, int Ai_unused_4) {
   double Ld_8;
   Gd_220 = 1000000000;
   Gd_228 = 0;
   for (int shift_16 = 0; shift_16 < Candles_per_TF + 1; shift_16++) {
      Ld_8 = iBands(Symbol(), A_timeframe_0, Period_, Deviations, Shift, ApplyTo, MODE_LOWER, shift_16);
      if (Ld_8 < Gd_220) Gd_220 = Ld_8;
      Ld_8 = iBands(Symbol(), A_timeframe_0, Period_, Deviations, Shift, ApplyTo, MODE_UPPER, shift_16);
      if (Ld_8 > Gd_228) Gd_228 = Ld_8;
      Ld_8 = iLow(Symbol(), A_timeframe_0, shift_16);
      if (Ld_8 < Gd_220) Gd_220 = Ld_8;
      Ld_8 = iHigh(Symbol(), A_timeframe_0, shift_16);
      if (Ld_8 > Gd_228) Gd_228 = Ld_8;
   }
}

// 58C7E3173A83184FE920CDD1203C3DCF
void f0_3() {
   int index_0 = 0;
   int Li_4 = 0;
   int Li_8 = 1;
   while (index_0 < 10 && Li_8 > 0) {
      Li_8 = StringFind(Timeframes, ",", Li_4);
      if (Li_8 == 0) Gsa_204[index_0] = StringSubstr(Timeframes, Li_4, 0);
      else Gsa_204[index_0] = StringSubstr(Timeframes, Li_4, Li_8 - Li_4);
      Gsa_204[index_0] = f0_9(Gsa_204[index_0]);
      index_0++;
      Li_4 = StringFind(Timeframes, ",", Li_4) + 1;
      if (Li_4 == 0) break;
   }
   Gi_188 = index_0;
}

// BE5275EB85F7B577DA8FD065F994B740
string f0_9(string As_0) {
   As_0 = f0_6(As_0);
   if (As_0 == "1") return ("M1");
   if (As_0 == "5") return ("M5");
   if (As_0 == "15") return ("M15");
   if (As_0 == "30") return ("M30");
   if (As_0 == "60") return ("H1");
   if (As_0 == "240") return ("H4");
   if (As_0 == "1440") return ("D1");
   if (As_0 == "10080") return ("W1");
   if (As_0 == "43200") return ("MN");
   return (As_0);
}

// 615FDEF187331094F307B857EA2ECFD3
int f0_4(string As_0) {
   int timeframe_8 = Period();
   if (As_0 == "M1" || As_0 == "1") timeframe_8 = 1;
   if (As_0 == "M5" || As_0 == "5") timeframe_8 = 5;
   if (As_0 == "M15" || As_0 == "15") timeframe_8 = 15;
   if (As_0 == "M30" || As_0 == "30") timeframe_8 = 30;
   if (As_0 == "H1" || As_0 == "60") timeframe_8 = 60;
   if (As_0 == "H4" || As_0 == "240") timeframe_8 = 240;
   if (As_0 == "D1" || As_0 == "1440") timeframe_8 = 1440;
   if (As_0 == "W1" || As_0 == "10080") timeframe_8 = 10080;
   if (As_0 == "MN" || As_0 == "43200") timeframe_8 = 43200;
   return (timeframe_8);
}

// 92DFF40263F725411B5FB6096A8D564E
string f0_6(string As_0) {
   int Li_20;
   string Ls_ret_8 = As_0;
   for (int Li_16 = StringLen(As_0) - 1; Li_16 >= 0; Li_16--) {
      Li_20 = StringGetChar(Ls_ret_8, Li_16);
      if ((Li_20 > '`' && Li_20 < '{') || (Li_20 > '' && Li_20 < 256)) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 - 32);
      else
         if (Li_20 > -33 && Li_20 < 0) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 + 224);
   }
   return (Ls_ret_8);
}

// 5891DA2D64975CAE48D175D1E001F5DA
void f0_2(string A_name_0, string A_text_8, int Ai_16, int A_datetime_20, double Ad_24, int A_datetime_32, double Ad_36, color A_color_44, int A_bool_48, string A_fontname_52, int A_fontsize_60) {
   if (ObjectFind(A_name_0) == -1) ObjectCreate(A_name_0, Ai_16, WindowFind(Gs_196), 0, 0, 0, 0);
   ObjectSet(A_name_0, OBJPROP_PRICE1, Ad_24);
   ObjectSet(A_name_0, OBJPROP_PRICE2, Ad_36);
   ObjectSet(A_name_0, OBJPROP_TIME1, A_datetime_20);
   ObjectSet(A_name_0, OBJPROP_TIME2, A_datetime_32);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_44);
   if (StringFind(A_name_0, "body") != -1) ObjectSet(A_name_0, OBJPROP_WIDTH, 3);
   else ObjectSet(A_name_0, OBJPROP_WIDTH, 1);
   ObjectSet(A_name_0, OBJPROP_BACK, A_bool_48);
   ObjectSet(A_name_0, OBJPROP_RAY, FALSE);
   ObjectSetText(A_name_0, A_text_8, A_fontsize_60, A_fontname_52, A_color_44);
}

// 7ED21143076D0CCA420653D4345BAA2F
void f0_5(string As_0) {
   if (SoundAlert) PlaySound("alert.wav");
   if (PopUpAlert) Alert("FFx BollingerBands Alert - ", As_0, " at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
   if (SendAlertEmail) SendMail("FFx BollingerBands Alert", "FFx BollingerBands Alert - " + As_0 + " at " + TimeToStr(TimeCurrent(), TIME_SECONDS) + " (server time)");
   if (SendAlertPush) SendNotification("FFx BollingerBands Alert - " + As_0 + " at " + TimeToStr(TimeCurrent(), TIME_SECONDS) + " (server time)");
}

// 205812AC4EF56AE14BAD4AAAA8876DCC
void f0_0() {
   string name_0 = "ferrufx";
   if (ObjectFind(name_0) == -1) ObjectCreate(name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name_0, OBJPROP_CORNER, 2);
   ObjectSet(name_0, OBJPROP_XDISTANCE, 3);
   ObjectSet(name_0, OBJPROP_YDISTANCE, 2);
   ObjectSetText(name_0, "FerruFx / www.ervent.net", 8, "Verdana", C'0x3C,0x3C,0x3C');
}